--- base/events.c.orig	2010-03-14 13:10:27.000000000 -0400
+++ base/events.c	2010-03-14 13:14:29.000000000 -0400
@@ -85,6 +85,8 @@
 
 extern int      time_change_threshold;
 
+extern int      use_large_installation_tweaks;
+
 timed_event *event_list_low=NULL;
 timed_event *event_list_low_tail=NULL;
 timed_event *event_list_high=NULL;
@@ -1143,19 +1145,22 @@
 			/* wait a while so we don't hog the CPU... */
 			else{
 
-				log_debug_info(DEBUGL_EVENTS,2,"Did not execute scheduled event.  Idling for a bit...\n");
+				/* Skipping this additional sleep time helps performance for large installations by noticeably reducing latency */
+				if(use_large_installation_tweaks==FALSE){
+					log_debug_info(DEBUGL_EVENTS,2,"Did not execute scheduled event.  Idling for a bit...\n");
 
 #ifdef USE_NANOSLEEP
-				delay.tv_sec=(time_t)sleep_time;
-				delay.tv_nsec=(long)((sleep_time-(double)delay.tv_sec)*1000000000);
-				nanosleep(&delay,NULL);
+					delay.tv_sec=(time_t)sleep_time;
+					delay.tv_nsec=(long)((sleep_time-(double)delay.tv_sec)*1000000000);
+					nanosleep(&delay,NULL);
 #else
-				delay.tv_sec=(time_t)sleep_time;
-				if(delay.tv_sec==0L)
-					delay.tv_sec=1;
-				delay.tv_nsec=0L;
-				sleep((unsigned int)delay.tv_sec);
+					delay.tv_sec=(time_t)sleep_time;
+					if(delay.tv_sec==0L)
+						delay.tv_sec=1;
+					delay.tv_nsec=0L;
+					sleep((unsigned int)delay.tv_sec);
 #endif
+					}
 			        }
 		        }
 
